
function a = toy2d(hyper) 

%====================================================================
% TOY2D toy data generation object
%==================================================================== 
% A=TOY(H) returns a toy object initialized with hyperparameters H. 
%
% This generates 2d toy data problem of two Gaussians.
% 
% Hyperparameters, and their defaults
%  l=20          -- examples
%  seed=-1       -- random seed used to generate it, if -1 do not
%                   set seed
% 
% Model
%  w             -- stores label model
%
% Methods:
%  generate,train,test
%
% Example:
% [r a]=train(svm('C=10'),toy2d); plot(a);

  a.l=20;
  a.n=2;
  a.seed=-1;
  
  p=algorithm('toy2d');
  a= class(a,'toy2d',p);

  if nargin==1
    eval_hyper;
  end  
