function d =  testing(alg,d,loss_type)  

allY = d.X;
A = alg.alpha.X;
B = alg.alpha.Y;
pi = alg.pi;

if alg.testing_mode == 0 % calc most probable state seq and LL
 
    for i = 1:length(allY)% initial checking and nonsense
        Y = allY{i};
        tau = length(Y); [M,statesN] = size(B); if(size(pi,2)~=1) pi=pi(:); end
        assert(alg,tau>0); assert(alg,length(pi)==statesN); assert(alg,max(Y)<=M); assert(alg,min(Y)>=1);
        
        % initialize space
        delta=zeros(statesN,tau);  psi=zeros(statesN,tau); qq=zeros(1,tau);
        
        % compute bb
        bb = B(Y,:)';
        
        % take logs of parameters for numerical ease, then use addition
        pi = log(pi+eps); A = log(A+eps); bb = log(bb+eps);
        
        delta(:,1) = pi+bb(:,1); 
        psi(:,1)=0;
        
        for tt=2:tau
            [delta(:,tt),psi(:,tt)] = max((delta(:,tt-1)*ones(1,statesN)+A)',[],2);
            delta(:,tt) = delta(:,tt)+bb(:,tt);
        end
        
        [ll,qq(tau)] = max(delta(:,tau));
        ll=ll/tau; % loglikelihood divided by the length of the sequence
        
        for tt=(tau-1):-1:1
            qq(tt)=psi(qq(tt+1),tt+1);
        end
        
        statesEst{i} = qq; 
        allLL(i) = ll;
    end
    
    
    d=set_y(d,allLL);
    d=set_x(d,statesEst);   
end

if alg.testing_mode == 1 %% generate most prob symbol seq modified by the weight vecs in Y (bows)
 
    B_backup = B; %store B
    for i = 1:length(allY)
        B = B_backup;
        Y = allY{i};
        N = sum(Y); % we want as many symbols as words  
        [M,statesN] = size(B);
 
        %% rescale B with an BoW vec so that that the sentence gets more
        %% probable (B = (symbN X states))
        B = B.*repmat(Y',1,statesN);
        B = B./(ones(M,1)*sum(B,1));  
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        B = cumsum(B,1);
        pi = cumsum(pi);
        if(~issparse(A)) A = cumsum(A,2); end
        % don't do the cumsum beforehand if A is big but sparse to avoid
        % allocating memory for a full sized A
        
        [Y,states]=genseq(alg,N,A,pi,B);
        
        allStates{i} = Y;
        seqs{i} = states;
    end   
     
    d=set_y(d,seqs);
    d=set_x(d,allStates);   
 
    
end


d=set_name(d,[get_name(d) ' -> ' get_name(alg)]);   
